<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;
$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();


if ( !isset($postdata['announcement_id']) or !checkIfIssetAndNotEmpty($postdata['announcement_id']) or
//   !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or 
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;


$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["principal"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);

function getSpecificAnnouncement($conn_rjllearning_specific,$institution_id,$branch_id,$announcement_id) {
 
    
    $sql = $conn_rjllearning_specific->prepare("SELECT * FROM  announcement where id = ? and institution_id =? and branch_id = ?");
    $sql->execute(array($announcement_id,$institution_id,$branch_id));
    $rows = $sql->fetchAll();

    if (count($rows) == 1) {
        if ($rows[0]['attachment'] != null and !is_array($rows[0]['attachment'])) {
            $data_attachment = json_decode($rows[0]['attachment'], true);
            $filePath = $data_attachment['filepath'];
            $originalName = $data_attachment['original_name'];
            $aws_attachment = displayFileFromS3($GLOBALS['s3_learning_bucket'], $GLOBALS['learning_bucketName'], $filePath);
            $final_array_attachment   = array("filepath" => $aws_attachment, "original_name" => $originalName);
        } else {
            $final_array_attachment =  null;
        }
        // if($rows[0]['class_id'] != 'all'){
        //  $class=getClass($conn_rjllearning_specific, $institution_id, $rows[0]['class_id']);
        // }else{
        //     $class =  'all';
            
        // }
        //  $branch_info =  getBranchInfo($conn_rjllearning_specific, $institution_id, $rows[0]['branch_id']);
        // $section =getSection($conn_rjllearning_specific, $institution_id, $rows[0]['section_id']);
        
        if ($rows[0]['branch_id'] == 'all') {
            $branch_info = array('branch_id' => 'all', 'name' => ucwords('all'));
        } else {
            $branch_info = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows[0]['branch_id']);
        }
        
        if ($rows[0]['class_id'] == 'all') {
            $class_info = array('class_id' => 'all', 'class_name' => ucwords('all'));
        }else {
        // Call the getClass function to fetch class information
        $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows[0]['class_id']);
    }
        
        // $section = getSection($conn_rjllearning_specific, $institution_id, $rows[0]['section_id']);
        $section_info = array();

        // print_r($section_id);
        // Check if JSON decoding failed or if it's a plain string
        if ($rows[0]['section_id'] === 'all') {
            $section = array('section_id' => 'all', 'section_name' => ucwords('all'));
        } else  {
        // If section_id is an array, fetch sections using getSection function
        $section = getSection($conn_rjllearning_specific, $institution_id, $rows[0]['section_id']);
    }
        return array('announcement_id'=> $rows[0]['id'],'branch_id'=>$branch_info ,'class_id'=> $class_info,'section_id'=>$section ,'title'=> $rows[0]['title'],'message'=> $rows[0]['message'],'attachment'=> $final_array_attachment);
      
    }else{
          errorreturn("Enter Invalid announcement info.");
    }

}

if($postdata['function_type']  == "fetch_specific_announcement") {  
    
    $announcement_id = trim($postdata['announcement_id']);
    
    $success['data'] = getSpecificAnnouncement($conn_rjllearning_specific,$institution_id,$branch_id,$announcement_id);
    successreturn($success);
      
}

